package com.yaoyicloud.controller;

import com.yaoyicloud.service.CsoReportService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.ByteArrayOutputStream;




/**
 * 报告控制器
 *
 * @author snows
 * @date 2024/10/14
 */
@RestController
@RequiredArgsConstructor
@Slf4j
@RequestMapping("/cso")
public class CsoReportController {
    private final CsoReportService csoReportService;

    @PostMapping(value = "/report/create-report", consumes = MediaType.APPLICATION_OCTET_STREAM_VALUE)
    public ResponseEntity<byte[]> handleReport(@RequestBody byte[] fileBytes) throws Exception {
        // 1. 直接获取PDF字节流
        ByteArrayOutputStream pdfStream = csoReportService.saveToTempFile(fileBytes);

        // 2. 转换为字节数组
        byte[] pdfBytes = pdfStream.toByteArray();

        // 3. 直接返回PDF字节流
        return ResponseEntity.ok()
                .contentType(MediaType.APPLICATION_PDF)  // 关键：设置为PDF类型
                .header("Content-Disposition", "attachment; filename=report.pdf")  // 设置下载文件名
                .body(pdfBytes);
    }
}
